(* Beware! Only edit allowed sections below    *)
(* This file is generated by Why3's Coq driver *)
Require Import ZArith.
Require Import Rbase.
Require Import Zdiv.
Parameter ghost : forall (a:Type), Type.

Definition unit  := unit.

Parameter ignore: forall (a:Type), a  -> unit.

Implicit Arguments ignore.

Parameter label_ : Type.

Parameter at1: forall (a:Type), a -> label_  -> a.

Implicit Arguments at1.

Parameter old: forall (a:Type), a  -> a.

Implicit Arguments old.

Axiom Abs_pos : forall (x:Z), (0%Z <= (Zabs x))%Z.

Axiom Div_mod : forall (x:Z) (y:Z), (~ (y = 0%Z)) ->
  (x = ((y * (Zdiv x y))%Z + (Zmod x y))%Z).

Axiom Div_bound : forall (x:Z) (y:Z), ((0%Z <= x)%Z /\ (0%Z <  y)%Z) ->
  ((0%Z <= (Zdiv x y))%Z /\ ((Zdiv x y) <= x)%Z).

Axiom Mod_bound : forall (x:Z) (y:Z), (~ (y = 0%Z)) ->
  ((0%Z <= (Zmod x y))%Z /\ ((Zmod x y) <  (Zabs y))%Z).

Axiom Mod_1 : forall (x:Z), ((Zmod x 1%Z) = 0%Z).

Axiom Div_1 : forall (x:Z), ((Zdiv x 1%Z) = x).

Parameter sum_multiple_3_5_lt: Z  -> Z.


Axiom SumEmpty : ((sum_multiple_3_5_lt 0%Z) = 0%Z).

Axiom SumNo : forall (n:Z), (0%Z <= n)%Z -> (((~ ((Zmod n 3%Z) = 0%Z)) /\
  ~ ((Zmod n 5%Z) = 0%Z)) ->
  ((sum_multiple_3_5_lt (n + 1%Z)%Z) = (sum_multiple_3_5_lt n))).

Axiom SumYes : forall (n:Z), (0%Z <= n)%Z -> ((((Zmod n 3%Z) = 0%Z) \/
  ((Zmod n 5%Z) = 0%Z)) ->
  ((sum_multiple_3_5_lt (n + 1%Z)%Z) = ((sum_multiple_3_5_lt n) + n)%Z)).

Theorem Closed_formula : forall (n:Z), (0%Z <= n)%Z -> let n3 :=
  (Zdiv n 3%Z) in let n5 := (Zdiv n 5%Z) in let n15 := (Zdiv n 15%Z) in
  let s :=
  (Zdiv ((((3%Z * n3)%Z * (n3 + 1%Z)%Z)%Z + ((5%Z * n5)%Z * (n5 + 1%Z)%Z)%Z)%Z - ((15%Z * n15)%Z * (n15 + 1%Z)%Z)%Z)%Z 2%Z) in
  (s = (sum_multiple_3_5_lt (n + 1%Z)%Z)).
(* YOU MAY EDIT THE PROOF BELOW *)
apply Zlt_lower_bound_ind.
intros n Hind Hpos.
assert (h: (n = 0 \/ n > 0)%Z) by omega.
destruct h.
(* case n=0 *)
subst; simpl.
rewrite Zdiv_0_l.
replace 1%Z with (0 + 1)%Z by omega.
rewrite SumYes; auto.
rewrite SumEmpty; auto.
(* case n > 0 *)
assert (h: (n mod 3 = 0 \/ n mod 3 <> 0)%Z) by omega.
destruct h.
(* case n mod 3 = 0 *)
assert (h: (n mod 5 = 0 \/ n mod 5 <> 0)%Z) by omega.
destruct h.
(* case n mod 3 = 0 and n mod 5 = 0 *)
rewrite SumYes; auto.
rewrite <- Hind; auto.

SearchAbout Zdiv.
rewrite <- (Z_div_exact_full_2 n 3).

assert (h: (n mod 5 = 0 \/ n mod 5 <> 0)%Z) by omega.
destruct h.

rewrite Zdiv0.
Qed.
(* DO NOT EDIT BELOW *)


